<!DOCTYPE html><html lang="zh-CN" data-theme="light"><head><meta charset="UTF-8"><meta http-equiv="X-UA-Compatible" content="IE=edge"><meta name="viewport" content="width=device-width,initial-scale=1"><title>StateFulSet | SeMaik</title><meta name="author" content="ZuSir"><meta name="copyright" content="ZuSir"><meta name="format-detection" content="telephone=no"><meta name="theme-color" content="#ffffff"><meta name="description" content="StatefulSet特性： 部署有状态应用  解决Pod独立生命周期，保持Pod启动顺序和唯一性 1、稳定，唯一的网络标识符，持久存储 2、有序，优雅的部署和扩展、删除和终止 3、有序，滚动更新  稳定得网络ID 使用Headless Service（相比普通得Service只是将spec.clusterIP定义为Node）来维护Pod网络身份； DNS解析名称：...svc.cluster.l">
<meta property="og:type" content="article">
<meta property="og:title" content="StateFulSet">
<meta property="og:url" content="http://example.com/2022/02/17/StateFulSet/index.html">
<meta property="og:site_name" content="SeMaik">
<meta property="og:description" content="StatefulSet特性： 部署有状态应用  解决Pod独立生命周期，保持Pod启动顺序和唯一性 1、稳定，唯一的网络标识符，持久存储 2、有序，优雅的部署和扩展、删除和终止 3、有序，滚动更新  稳定得网络ID 使用Headless Service（相比普通得Service只是将spec.clusterIP定义为Node）来维护Pod网络身份； DNS解析名称：...svc.cluster.l">
<meta property="og:locale" content="zh_CN">
<meta property="og:image" content="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg">
<meta property="article:published_time" content="2022-02-17T02:21:00.000Z">
<meta property="article:modified_time" content="2022-02-17T02:21:23.789Z">
<meta property="article:author" content="ZuSir">
<meta name="twitter:card" content="summary">
<meta name="twitter:image" content="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg"><link rel="shortcut icon" href="https://myit.icu/favicon.ico"><link rel="canonical" href="http://example.com/2022/02/17/StateFulSet/"><link rel="preconnect" href="//cdn.jsdelivr.net"/><link rel="preconnect" href="//busuanzi.ibruce.info"/><link rel="stylesheet" href="/css/index.css"><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@fortawesome/fontawesome-free/css/all.min.css" media="print" onload="this.media='all'"><script>const GLOBAL_CONFIG = { 
  root: '/',
  algolia: undefined,
  localSearch: undefined,
  translate: undefined,
  noticeOutdate: undefined,
  highlight: {"plugin":"highlighjs","highlightCopy":true,"highlightLang":true},
  copy: {
    success: '复制成功',
    error: '复制错误',
    noSupport: '浏览器不支持'
  },
  relativeDate: {
    homepage: true,
    post: false
  },
  runtime: '',
  date_suffix: {
    just: '刚刚',
    min: '分钟前',
    hour: '小时前',
    day: '天前',
    month: '个月前'
  },
  copyright: undefined,
  lightbox: 'fancybox',
  Snackbar: undefined,
  source: {
    jQuery: 'https://cdn.jsdelivr.net/npm/jquery@latest/dist/jquery.min.js',
    justifiedGallery: {
      js: 'https://cdn.jsdelivr.net/npm/justifiedGallery/dist/js/jquery.justifiedGallery.min.js',
      css: 'https://cdn.jsdelivr.net/npm/justifiedGallery/dist/css/justifiedGallery.min.css'
    },
    fancybox: {
      js: 'https://cdn.jsdelivr.net/npm/@fancyapps/fancybox@latest/dist/jquery.fancybox.min.js',
      css: 'https://cdn.jsdelivr.net/npm/@fancyapps/fancybox@latest/dist/jquery.fancybox.min.css'
    }
  },
  isPhotoFigcaption: false,
  islazyload: false,
  isanchor: false
}</script><script id="config-diff">var GLOBAL_CONFIG_SITE = { 
  isPost: true,
  isHome: false,
  isHighlightShrink: undefined,
  isToc: true,
  postUpdate: '2022-02-17 10:21:23'
}</script><noscript><style type="text/css">
  #nav {
    opacity: 1
  }
  .justified-gallery img {
    opacity: 1
  }

  #recent-posts time,
  #post-meta time {
    display: inline !important
  }
</style></noscript><script>(win=>{
    win.saveToLocal = {
      set: function setWithExpiry(key, value, ttl) {
        if (ttl === 0) return
        const now = new Date()
        const expiryDay = ttl * 86400000
        const item = {
          value: value,
          expiry: now.getTime() + expiryDay,
        }
        localStorage.setItem(key, JSON.stringify(item))
      },

      get: function getWithExpiry(key) {
        const itemStr = localStorage.getItem(key)

        if (!itemStr) {
          return undefined
        }
        const item = JSON.parse(itemStr)
        const now = new Date()

        if (now.getTime() > item.expiry) {
          localStorage.removeItem(key)
          return undefined
        }
        return item.value
      }
    }
  
    win.getScript = url => new Promise((resolve, reject) => {
      const script = document.createElement('script')
      script.src = url
      script.async = true
      script.onerror = reject
      script.onload = script.onreadystatechange = function() {
        const loadState = this.readyState
        if (loadState && loadState !== 'loaded' && loadState !== 'complete') return
        script.onload = script.onreadystatechange = null
        resolve()
      }
      document.head.appendChild(script)
    })
  
      const asideStatus = saveToLocal.get('aside-status')
      if (asideStatus !== undefined) {
        if (asideStatus === 'hide') {
          document.documentElement.classList.add('hide-aside')
        } else {
          document.documentElement.classList.remove('hide-aside')
        }
      }
    })(window)</script><link href="/css/style.css"><meta name="generator" content="Hexo 5.3.0"><link rel="alternate" href="/atom.xml" title="SeMaik" type="application/atom+xml">
</head><body><div id="web_bg"></div><div id="sidebar"><div id="menu-mask"></div><div id="sidebar-menus"><div class="author-avatar"><img class="avatar-img" src="/img/123.jpeg" onerror="onerror=null;src='/img/123.jpeg'" alt="avatar"/></div><div class="site-data"><div class="data-item is-center"><div class="data-item-link"><a href="/archives/"><div class="headline">文章</div><div class="length-num">152</div></a></div></div><div class="data-item is-center"><div class="data-item-link"><a href="/categories/"><div class="headline">分类</div><div class="length-num">37</div></a></div></div></div><hr/><div class="menus_items"><div class="menus_item"><a class="site-page" href="/"><i class="fa-fw fas fa-home"></i><span> 首页</span></a></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Linux</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Linux/"><span> Linux</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> WEB</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Apache/"><span> Apache</span></a></li><li><a class="site-page" href="/categories/Nginx/"><span> Nginx</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 存储</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ceph/"><span> Ceph</span></a></li><li><a class="site-page" href="/categories/NFS/"><span> NFS</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 日志</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Loki"><span> Loki</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 编程</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Shell"><span> Shell</span></a></li><li><a class="site-page" href="/categories/Python"><span> Python</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 高可用</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/KeepAlived/"><span> KeepAlived</span></a></li><li><a class="site-page" href="/categories/LVS/"><span> LVS</span></a></li><li><a class="site-page" href="/categories/Squid/"><span> Squid</span></a></li><li><a class="site-page" href="/categories/Haproxy/"><span> Haproxy</span></a></li><li><a class="site-page" href="/categories/Rsync/"><span> Rsync</span></a></li><li><a class="site-page" href="/categories/Memcache/"><span> Memcache</span></a></li><li><a class="site-page" href="/categories/Varnish/"><span> Varnish</span></a></li><li><a class="site-page" href="/categories/GRedis/"><span> Redis</span></a></li><li><a class="site-page" href="/categories/Rabbit/"><span> RabbitMQ</span></a></li><li><a class="site-page" href="/categories/Kafka/"><span> Kafka</span></a></li><li><a class="site-page" href="/categories/MHA/"><span> MHA</span></a></li><li><a class="site-page" href="/categories/PXC/"><span> PXC</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 虚拟化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Docker/"><span> Docker</span></a></li><li><a class="site-page" href="/categories/Kubernetes/"><span> Kubernetes</span></a></li><li><a class="site-page" href="/categories/OpenStack/"><span> OpenStack</span></a></li><li><a class="site-page" href="/categories/KVM/"><span> KVM</span></a></li><li><a class="site-page" href="/categories/Containerd"><span> Containerd</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Hexo</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Hexo/"><span> Hexo</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 数据库</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/MySQL/"><span> MySQL</span></a></li><li><a class="site-page" href="/categories/Readis/"><span> Readis</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 微服务</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Tomcat/"><span> Tomcat</span></a></li><li><a class="site-page" href="/categories/Git/"><span> Git</span></a></li><li><a class="site-page" href="/categories/Maven/"><span> Maven</span></a></li><li><a class="site-page" href="/categories/Nexus/"><span> Nexus</span></a></li><li><a class="site-page" href="/categories/Jenkins/"><span> Jenkins</span></a></li><li><a class="site-page" href="/categories/Spring/"><span> Spring</span></a></li><li><a class="site-page" href="/categories/Consul/"><span> Consul</span></a></li><li><a class="site-page" href="/categories/Harbor/"><span> Harbor</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 自动化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ansible/"><span> Ansible</span></a></li><li><a class="site-page" href="/categories/Pssh/"><span> Pssh</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="/link/"><i class="fa-fw fas fa-link"></i><span> 友链</span></a></div><div class="menus_item"><a class="site-page" href="/about/"><i class="fa-fw fas fa-heart"></i><span> 关于</span></a></div></div></div></div><div class="post" id="body-wrap"><header class="post-bg" id="page-header" style="background-image: url('https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg')"><nav id="nav"><span id="blog_name"><a id="site-name" href="/">SeMaik</a></span><div id="menus"><div class="menus_items"><div class="menus_item"><a class="site-page" href="/"><i class="fa-fw fas fa-home"></i><span> 首页</span></a></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Linux</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Linux/"><span> Linux</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> WEB</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Apache/"><span> Apache</span></a></li><li><a class="site-page" href="/categories/Nginx/"><span> Nginx</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 存储</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ceph/"><span> Ceph</span></a></li><li><a class="site-page" href="/categories/NFS/"><span> NFS</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 日志</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Loki"><span> Loki</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 编程</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Shell"><span> Shell</span></a></li><li><a class="site-page" href="/categories/Python"><span> Python</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 高可用</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/KeepAlived/"><span> KeepAlived</span></a></li><li><a class="site-page" href="/categories/LVS/"><span> LVS</span></a></li><li><a class="site-page" href="/categories/Squid/"><span> Squid</span></a></li><li><a class="site-page" href="/categories/Haproxy/"><span> Haproxy</span></a></li><li><a class="site-page" href="/categories/Rsync/"><span> Rsync</span></a></li><li><a class="site-page" href="/categories/Memcache/"><span> Memcache</span></a></li><li><a class="site-page" href="/categories/Varnish/"><span> Varnish</span></a></li><li><a class="site-page" href="/categories/GRedis/"><span> Redis</span></a></li><li><a class="site-page" href="/categories/Rabbit/"><span> RabbitMQ</span></a></li><li><a class="site-page" href="/categories/Kafka/"><span> Kafka</span></a></li><li><a class="site-page" href="/categories/MHA/"><span> MHA</span></a></li><li><a class="site-page" href="/categories/PXC/"><span> PXC</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 虚拟化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Docker/"><span> Docker</span></a></li><li><a class="site-page" href="/categories/Kubernetes/"><span> Kubernetes</span></a></li><li><a class="site-page" href="/categories/OpenStack/"><span> OpenStack</span></a></li><li><a class="site-page" href="/categories/KVM/"><span> KVM</span></a></li><li><a class="site-page" href="/categories/Containerd"><span> Containerd</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Hexo</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Hexo/"><span> Hexo</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 数据库</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/MySQL/"><span> MySQL</span></a></li><li><a class="site-page" href="/categories/Readis/"><span> Readis</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 微服务</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Tomcat/"><span> Tomcat</span></a></li><li><a class="site-page" href="/categories/Git/"><span> Git</span></a></li><li><a class="site-page" href="/categories/Maven/"><span> Maven</span></a></li><li><a class="site-page" href="/categories/Nexus/"><span> Nexus</span></a></li><li><a class="site-page" href="/categories/Jenkins/"><span> Jenkins</span></a></li><li><a class="site-page" href="/categories/Spring/"><span> Spring</span></a></li><li><a class="site-page" href="/categories/Consul/"><span> Consul</span></a></li><li><a class="site-page" href="/categories/Harbor/"><span> Harbor</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 自动化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ansible/"><span> Ansible</span></a></li><li><a class="site-page" href="/categories/Pssh/"><span> Pssh</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="/link/"><i class="fa-fw fas fa-link"></i><span> 友链</span></a></div><div class="menus_item"><a class="site-page" href="/about/"><i class="fa-fw fas fa-heart"></i><span> 关于</span></a></div></div><div id="toggle-menu"><a class="site-page"><i class="fas fa-bars fa-fw"></i></a></div></div></nav><div id="post-info"><h1 class="post-title">StateFulSet</h1><div id="post-meta"><div class="meta-firstline"><span class="post-meta-date"><i class="far fa-calendar-alt fa-fw post-meta-icon"></i><span class="post-meta-label">发表于</span><time class="post-meta-date-created" datetime="2022-02-17T02:21:00.000Z" title="发表于 2022-02-17 10:21:00">2022-02-17</time><span class="post-meta-separator">|</span><i class="fas fa-history fa-fw post-meta-icon"></i><span class="post-meta-label">更新于</span><time class="post-meta-date-updated" datetime="2022-02-17T02:21:23.789Z" title="更新于 2022-02-17 10:21:23">2022-02-17</time></span><span class="post-meta-categories"><span class="post-meta-separator">|</span><i class="fas fa-inbox fa-fw post-meta-icon"></i><a class="post-meta-categories" href="/categories/Kubernetes/">Kubernetes</a></span></div><div class="meta-secondline"><span class="post-meta-separator">|</span><span class="post-meta-pv-cv"><i class="far fa-eye fa-fw post-meta-icon"></i><span class="post-meta-label">阅读量:</span><span id="busuanzi_value_page_pv"></span></span></div></div></div></header><main class="layout" id="content-inner"><div id="post"><article class="post-content" id="article-container"><h2 id="StatefulSet特性："><a href="#StatefulSet特性：" class="headerlink" title="StatefulSet特性："></a>StatefulSet特性：</h2><ul>
<li><p>部署有状态应用</p>
</li>
<li><p>解决Pod独立生命周期，保持Pod启动顺序和唯一性</p>
<p>1、稳定，唯一的网络标识符，持久存储</p>
<p>2、有序，优雅的部署和扩展、删除和终止</p>
<p>3、有序，滚动更新</p>
</li>
<li><p>稳定得网络ID</p>
<p>使用Headless Service（相比普通得Service只是将spec.clusterIP定义为Node）来维护Pod网络身份；</p>
<p>DNS解析名称：<statefulset-index>.<service-name>.<namespace-name>.svc.cluster.local</p>
</li>
<li><p>稳定的存储</p>
<p>Statefulset得存储卷使用VolumeClaimTemplate创建，成为卷申请模板，当statefulset使用VolumeClaimTemplate创建一个PersistentVolume时，同样也会为每个Pod分配并创建一个编号得PVC；</p>
</li>
</ul>
<h2 id="StatefulSet-Pod部署"><a href="#StatefulSet-Pod部署" class="headerlink" title="StatefulSet-Pod部署"></a>StatefulSet-Pod部署</h2><figure class="highlight sh"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br><span class="line">15</span><br><span class="line">16</span><br><span class="line">17</span><br><span class="line">18</span><br><span class="line">19</span><br><span class="line">20</span><br><span class="line">21</span><br><span class="line">22</span><br><span class="line">23</span><br><span class="line">24</span><br><span class="line">25</span><br><span class="line">26</span><br><span class="line">27</span><br><span class="line">28</span><br><span class="line">29</span><br><span class="line">30</span><br><span class="line">31</span><br><span class="line">32</span><br><span class="line">33</span><br><span class="line">34</span><br><span class="line">35</span><br><span class="line">36</span><br><span class="line">37</span><br><span class="line">38</span><br><span class="line">39</span><br><span class="line">40</span><br><span class="line">41</span><br><span class="line">42</span><br><span class="line">43</span><br><span class="line">44</span><br><span class="line">45</span><br><span class="line">46</span><br><span class="line">47</span><br><span class="line">48</span><br><span class="line">49</span><br><span class="line">50</span><br><span class="line">51</span><br><span class="line">52</span><br><span class="line">53</span><br><span class="line">54</span><br><span class="line">55</span><br><span class="line">56</span><br><span class="line">57</span><br><span class="line">58</span><br></pre></td><td class="code"><pre><span class="line">[root@pool1 k8s_yaml]<span class="comment"># vi statefulset.yaml</span></span><br><span class="line">apiVersion: v1</span><br><span class="line">kind: Service</span><br><span class="line">metadata:</span><br><span class="line">  name: nginx</span><br><span class="line">  labels:</span><br><span class="line">    app: nginx</span><br><span class="line">spec:</span><br><span class="line">  ports:</span><br><span class="line">  - port: 80</span><br><span class="line">    name: web</span><br><span class="line">  clusterIP: None</span><br><span class="line">  selector:</span><br><span class="line">    app: nginx</span><br><span class="line">---</span><br><span class="line">apiVersion: apps/v1</span><br><span class="line">kind: StatefulSet</span><br><span class="line">metadata:</span><br><span class="line">  name: web</span><br><span class="line">spec:</span><br><span class="line">  selector:</span><br><span class="line">    matchLabels:</span><br><span class="line">      app: nginx <span class="comment"># has to match .spec.template.metadata.labels</span></span><br><span class="line">  serviceName: <span class="string">&quot;nginx&quot;</span></span><br><span class="line">  replicas: 3 <span class="comment"># by default is 1</span></span><br><span class="line">  template:</span><br><span class="line">    metadata:</span><br><span class="line">      labels:</span><br><span class="line">        app: nginx <span class="comment"># has to match .spec.selector.matchLabels</span></span><br><span class="line">    spec:</span><br><span class="line">      terminationGracePeriodSeconds: 10</span><br><span class="line">      containers:</span><br><span class="line">      - name: nginx</span><br><span class="line">        image: nginx:1.20</span><br><span class="line">        imagePullPolicy: IfNotPresent </span><br><span class="line">        ports:</span><br><span class="line">        - containerPort: 80</span><br><span class="line">          name: web</span><br><span class="line">        volumeMounts:</span><br><span class="line">        - name: www</span><br><span class="line">          mountPath: /usr/share/nginx/html</span><br><span class="line">  volumeClaimTemplates:	<span class="comment"># StatefuSet特有的存储机制</span></span><br><span class="line">  - metadata:</span><br><span class="line">      name: www</span><br><span class="line">    spec:</span><br><span class="line">      accessModes: [ <span class="string">&quot;ReadWriteOnce&quot;</span> ]	<span class="comment"># 访问模式</span></span><br><span class="line">      storageClassName: <span class="string">&quot;managed-nfs-storage&quot;</span>  <span class="comment"># 动态PV名称</span></span><br><span class="line">      resources:</span><br><span class="line">        requests:</span><br><span class="line">          storage: 1Gi</span><br><span class="line">[root@pool1 k8s_yaml]<span class="comment"># kubectl apply -f statefulset.yaml </span></span><br><span class="line">service/nginx created</span><br><span class="line">statefulset.apps/web created</span><br><span class="line"></span><br><span class="line">[root@pool1 k8s_yaml]<span class="comment"># kubectl get pod | grep web</span></span><br><span class="line">web-0                                     1/1     Running   0          22m</span><br><span class="line">web-1                                     1/1     Running   0          22m</span><br><span class="line">web-2                                     1/1     Running   0          22m</span><br></pre></td></tr></table></figure>
<h2 id="获取pod得DNS域名解析"><a href="#获取pod得DNS域名解析" class="headerlink" title="获取pod得DNS域名解析"></a>获取pod得DNS域名解析</h2><figure class="highlight sh"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br><span class="line">15</span><br><span class="line">16</span><br><span class="line">17</span><br><span class="line">18</span><br><span class="line">19</span><br><span class="line">20</span><br><span class="line">21</span><br><span class="line">22</span><br><span class="line">23</span><br><span class="line">24</span><br><span class="line">25</span><br><span class="line">26</span><br><span class="line">27</span><br><span class="line">28</span><br><span class="line">29</span><br><span class="line">30</span><br><span class="line">31</span><br><span class="line">32</span><br><span class="line">33</span><br><span class="line">34</span><br></pre></td><td class="code"><pre><span class="line">[root@pool1 k8s_yaml]<span class="comment"># kubectl run -it test --image=busybox:1.28.4 -- sh</span></span><br><span class="line">/ <span class="comment"># nslookup nginx</span></span><br><span class="line">Server:    10.96.0.10</span><br><span class="line">Address 1: 10.96.0.10 kube-dns.kube-system.svc.cluster.local</span><br><span class="line"></span><br><span class="line">Name:      nginx</span><br><span class="line">Address 1: 10.244.206.14 web-0.nginx.default.svc.cluster.local</span><br><span class="line">Address 2: 10.244.52.201 web-2.nginx.default.svc.cluster.local</span><br><span class="line">Address 3: 10.244.206.15 web-1.nginx.default.svc.cluster.local</span><br><span class="line">/ <span class="comment"># ping web-0.nginx.default.svc.cluster.local</span></span><br><span class="line">PING web-0.nginx.default.svc.cluster.local (10.244.206.14): 56 data bytes</span><br><span class="line">64 bytes from 10.244.206.14: seq=0 ttl=62 time=0.689 ms</span><br><span class="line">^C</span><br><span class="line">--- web-0.nginx.default.svc.cluster.local ping statistics ---</span><br><span class="line">1 packets transmitted, 1 packets received, 0% packet loss</span><br><span class="line">round-trip min/avg/max = 0.689/0.689/0.689 ms</span><br><span class="line">/ <span class="comment"># ping web-2.nginx.default.svc.cluster.local</span></span><br><span class="line">PING web-2.nginx.default.svc.cluster.local (10.244.52.201): 56 data bytes</span><br><span class="line">64 bytes from 10.244.52.201: seq=0 ttl=62 time=0.354 ms</span><br><span class="line">64 bytes from 10.244.52.201: seq=1 ttl=62 time=0.391 ms</span><br><span class="line">^C</span><br><span class="line">--- web-2.nginx.default.svc.cluster.local ping statistics ---</span><br><span class="line">2 packets transmitted, 2 packets received, 0% packet loss</span><br><span class="line">round-trip min/avg/max = 0.354/0.372/0.391 ms</span><br><span class="line">/ <span class="comment"># ping web-1.nginx.default.svc.cluster.local</span></span><br><span class="line">PING web-1.nginx.default.svc.cluster.local (10.244.206.15): 56 data bytes</span><br><span class="line">64 bytes from 10.244.206.15: seq=0 ttl=62 time=0.851 ms</span><br><span class="line">64 bytes from 10.244.206.15: seq=1 ttl=62 time=1.290 ms</span><br><span class="line">^C</span><br><span class="line">--- web-1.nginx.default.svc.cluster.local ping statistics ---</span><br><span class="line">2 packets transmitted, 2 packets received, 0% packet loss</span><br><span class="line">round-trip min/avg/max = 0.851/1.070/1.290 ms</span><br><span class="line"></span><br><span class="line"><span class="comment"># 这时可以通过nslookup解析的域名来让其他服务进行关联，保证每个Pod都有唯一联系地址；而不是通过svc来实现服务发现及负载均衡；</span></span><br></pre></td></tr></table></figure>
</article><div class="post-copyright"><div class="post-copyright__author"><span class="post-copyright-meta">文章作者: </span><span class="post-copyright-info"><a href="mailto:undefined">ZuSir</a></span></div><div class="post-copyright__type"><span class="post-copyright-meta">文章链接: </span><span class="post-copyright-info"><a href="http://example.com/2022/02/17/StateFulSet/">http://example.com/2022/02/17/StateFulSet/</a></span></div><div class="post-copyright__notice"><span class="post-copyright-meta">版权声明: </span><span class="post-copyright-info">本博客所有文章除特别声明外，均采用 <a href="https://creativecommons.org/licenses/by-nc-sa/4.0/" target="_blank">CC BY-NC-SA 4.0</a> 许可协议。转载请注明来自 <a href="http://example.com" target="_blank">SeMaik</a>！</span></div></div><div class="tag_share"><div class="post-meta__tag-list"></div><div class="post_share"><div class="social-share" data-image="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" data-sites="facebook,twitter,wechat,weibo,qq"></div><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/social-share.js/dist/css/share.min.css" media="print" onload="this.media='all'"><script src="https://cdn.jsdelivr.net/npm/social-share.js/dist/js/social-share.min.js" defer></script></div></div><nav class="pagination-post" id="pagination"><div class="prev-post pull-left"><a href="/2022/02/17/me/"><img class="prev-cover" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" onerror="onerror=null;src='/img/123.jpeg'" alt="cover of previous post"><div class="pagination-info"><div class="label">上一篇</div><div class="prev_info">Metrics Server监控集群资源</div></div></a></div><div class="next-post pull-right"><a href="/2022/02/17/%E4%BB%8A%E5%A4%A9/"><img class="next-cover" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" onerror="onerror=null;src='/img/123.jpeg'" alt="cover of next post"><div class="pagination-info"><div class="label">下一篇</div><div class="next_info">Static Pod(静态Pod)</div></div></a></div></nav></div><div class="aside-content" id="aside-content"><div class="card-widget card-info"><div class="card-info-avatar is-center"><img class="avatar-img" src="/img/123.jpeg" onerror="this.onerror=null;this.src='/img/123.jpeg'" alt="avatar"/><div class="author-info__name">ZuSir</div><div class="author-info__description">一个收藏回忆与分享技术的地方!</div></div><div class="card-info-data"><div class="card-info-data-item is-center"><a href="/archives/"><div class="headline">文章</div><div class="length-num">152</div></a></div><div class="card-info-data-item is-center"><a href="/categories/"><div class="headline">分类</div><div class="length-num">37</div></a></div></div></div><div class="card-widget card-announcement"><div class="item-headline"><i class="fas fa-bullhorn card-announcement-animation"></i><span>公告</span></div><div class="announcement_content">This is my Blog! <img src="https://ss0.bdstatic.com/70cFuHSh_Q1YnxGkpoWK1HF6hhy/it/u=3894415926,2787041726&fm=26&gp=0.jpg"></div></div><div class="sticky_layout"><div class="card-widget" id="card-toc"><div class="item-headline"><i class="fas fa-stream"></i><span>目录</span></div><div class="toc-content"><ol class="toc"><li class="toc-item toc-level-2"><a class="toc-link" href="#StatefulSet%E7%89%B9%E6%80%A7%EF%BC%9A"><span class="toc-number">1.</span> <span class="toc-text">StatefulSet特性：</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#StatefulSet-Pod%E9%83%A8%E7%BD%B2"><span class="toc-number">2.</span> <span class="toc-text">StatefulSet-Pod部署</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#%E8%8E%B7%E5%8F%96pod%E5%BE%97DNS%E5%9F%9F%E5%90%8D%E8%A7%A3%E6%9E%90"><span class="toc-number">3.</span> <span class="toc-text">获取pod得DNS域名解析</span></a></li></ol></div></div><div class="card-widget card-recent-post"><div class="item-headline"><i class="fas fa-history"></i><span>最新文章</span></div><div class="aside-list"><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E9%83%A8%E7%BD%B2Zabbix-Server5-0/" title="Shell程序——部署Zabbix-ServerV5.0">Shell程序——部署Zabbix-ServerV5.0</a><time datetime="2022-02-17T03:32:00.000Z" title="发表于 2022-02-17 11:32:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E9%83%A8%E7%BD%B2Harbor/" title="Shell程序——部署Harbor">Shell程序——部署Harbor</a><time datetime="2022-02-17T03:31:00.000Z" title="发表于 2022-02-17 11:31:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94Mysql%E5%A4%87%E4%BB%BD/" title="Shell程序——Mysql备份">Shell程序——Mysql备份</a><time datetime="2022-02-17T03:30:00.000Z" title="发表于 2022-02-17 11:30:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E6%89%B9%E9%87%8F%E4%BF%9D%E5%AD%98Docker-image/" title="Shell程序——批量保存Docker_image">Shell程序——批量保存Docker_image</a><time datetime="2022-02-17T03:29:00.000Z" title="发表于 2022-02-17 11:29:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E5%85%A8%E6%AE%B5IP%E6%89%AB%E6%8F%8F/" title="Shell程序——全段IP扫描">Shell程序——全段IP扫描</a><time datetime="2022-02-17T03:28:00.000Z" title="发表于 2022-02-17 11:28:00">2022-02-17</time></div></div></div></div></div></div></main><footer id="footer"><div id="footer-wrap"><div class="copyright">&copy;2020 - 2022 By ZuSir</div><div class="framework-info"><span>框架 </span><a target="_blank" rel="noopener" href="https://hexo.io">Hexo</a><span class="footer-separator">|</span><span>主题 </span><a target="_blank" rel="noopener" href="https://github.com/jerryc127/hexo-theme-butterfly">Butterfly</a></div></div></footer></div><div id="rightside"><div id="rightside-config-hide"><button id="readmode" type="button" title="阅读模式"><i class="fas fa-book-open"></i></button><button id="hide-aside-btn" type="button" title="单栏和双栏切换"><i class="fas fa-arrows-alt-h"></i></button></div><div id="rightside-config-show"><button id="rightside_config" type="button" title="设置"><i class="fas fa-cog fa-spin"></i></button><button class="close" id="mobile-toc-button" type="button" title="目录"><i class="fas fa-list-ul"></i></button><button id="go-up" type="button" title="回到顶部"><i class="fas fa-arrow-up"></i></button></div></div><div><script src="/js/utils.js"></script><script src="/js/main.js"></script><div class="js-pjax"></div><script defer="defer" id="fluttering_ribbon" mobile="true" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/dist/canvas-fluttering-ribbon.min.js"></script><script async data-pjax src="//busuanzi.ibruce.info/busuanzi/2.3/busuanzi.pure.mini.js"></script></div></body></html>